Index: /trunk/source/Lib/TLibDecoder/TDecConformance.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecConformance.h	(revision 1413)
+++ /trunk/source/Lib/TLibDecoder/TDecConformance.h	(revision 1413)
@@ -0,0 +1,264 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** \file     TDecConformance.h
+    \brief    Decoder conformance functions (header)
+*/
+
+#ifndef __TDECCONFORMANCE__
+#define __TDECCONFORMANCE__
+
+// This can be enabled externally. Note that this is a PARTIAL CONFORMANCE CHECK - not a full check. More checks may be added later
+#ifndef DECODER_PARTIAL_CONFORMANCE_CHECK
+#define DECODER_PARTIAL_CONFORMANCE_CHECK                 0 ///< 0 (default) = do not check conformance. 1 = warn if conformance checks fail. 2 = error and quit if conformance checks fail. Note this is only a partial conformance check - not a full conformance check.
+#endif
+
+
+
+#if _MSC_VER > 1000
+#pragma once
+#endif // _MSC_VER > 1000
+
+#include "TLibCommon/CommonDef.h"
+#include <stdio.h>
+#include <iostream>
+#if DECODER_PARTIAL_CONFORMANCE_CHECK == 2
+#include <stdlib.h>
+#endif
+
+
+// Forward declarations
+class TComSlice;
+class TComSPS;
+class TComPPS;
+class InputNALUnit;
+class TComPTL;
+class TComPic;
+
+typedef enum TRISTATE
+{
+  DISABLED=0,
+  OPTIONAL=1,
+  ENABLED=2
+} TRISTATE;
+
+
+typedef enum HBRFACTOREQN
+{
+  HBR_1 = 0,
+  HBR_1_OR_2 = 1,
+  HBR_12_OR_24 = 2
+} HBRFACTOREQN;
+
+
+struct LevelTierFeatures
+{
+  Level::Name level;
+  UInt        maxLumaPs;
+  UInt        maxCpb[Level::NUMBER_OF_TIERS];    // in units of CpbVclFactor or CpbNalFactor bits
+  UInt        maxSliceSegmentsPerPicture;
+  UInt        maxTileRows;
+  UInt        maxTileCols;
+  UInt64      maxLumaSr;
+  UInt        maxBr[Level::NUMBER_OF_TIERS];     // in units of BrVclFactor or BrNalFactor bits/s
+  UInt        minCrBase[Level::NUMBER_OF_TIERS];
+  UInt        getMaxPicWidthInLumaSamples()  const;
+  UInt        getMaxPicHeightInLumaSamples() const;
+};
+
+
+struct ProfileFeatures
+{
+  Profile::Name            profile;
+  const TChar            *pNameString;
+  UInt                     maxBitDepth;
+  ChromaFormat             maxChromaFormat;
+  Bool                     generalIntraConstraintFlag;
+  Bool                     generalOnePictureOnlyConstraintFlag;
+  TRISTATE                 generalLowerBitRateConstraint;
+  TRISTATE                 generalRExtToolsEnabled;
+  TRISTATE                 extendedPrecisionProcessingFlag;
+  TRISTATE                 chromaQpOffsetListEnabledFlag;
+  TRISTATE                 cabacBypassAlignmentEnabledFlag;
+  HBRFACTOREQN             hbrFactorEqn;
+  Bool                     bWavefrontsAndTilesCanBeUsedSimultaneously;
+
+  UInt                     minTileColumnWidthInLumaSamples;
+  UInt                     minTileRowHeightInLumaSamples;
+  Bool                     bCanUseLevel8p5;
+  UInt                     cpbVclFactor;
+  UInt                     cpbNalFactor;                // currently not used for checking
+  UInt                     formatCapabilityFactorx1000; // currently not used for checking
+  UInt                     minCrScaleFactorx10;         // currently not used for checking
+  const LevelTierFeatures *pLevelTiersListInfo;
+
+  Bool chromaFormatValid(ChromaFormat chFmt) const { return (profile == Profile::MAINREXT || profile == Profile::HIGHTHROUGHPUTREXT) ? chFmt<=maxChromaFormat : (chFmt == maxChromaFormat ); }
+  Bool onlyIRAPPictures()                    const { return generalIntraConstraintFlag; }
+  UInt getHbrFactor(Bool bLowerBitRateConstraintFlag) const    // currently not used for checking
+  {
+    return hbrFactorEqn==HBR_1_OR_2   ? (2-(bLowerBitRateConstraintFlag?1:0)) :
+          (hbrFactorEqn==HBR_12_OR_24 ? 12*(2-(bLowerBitRateConstraintFlag?1:0)) :
+                                        1);
+  }
+};
+
+
+class ProfileLevelTierFeatures
+{
+  private:
+    const ProfileFeatures   *m_pProfile;
+    const LevelTierFeatures *m_pLevelTier;
+    UInt                     m_hbrFactor;               // currently not used for checking
+    Level::Tier              m_tier;
+    UInt                     m_maxRawCtuBits;
+  public:
+    ProfileLevelTierFeatures() : m_pProfile(0), m_pLevelTier(0), m_hbrFactor(0), m_tier(Level::MAIN), m_maxRawCtuBits(0) { }
+
+    Void activate(const TComSPS &sps);
+
+    const ProfileFeatures     *getProfileFeatures()   const { return m_pProfile; }
+    const LevelTierFeatures   *getLevelTierFeatures() const { return m_pLevelTier; }
+    Level::Tier                getTier() const { return m_tier; }
+    UInt64 getCpbSizeInBits()            const { return (m_pLevelTier!=0 && m_pProfile!=0) ? UInt64(m_pProfile->cpbVclFactor) * m_pLevelTier->maxCpb[m_tier?1:0] : UInt64(0); }
+    Double getMinCr()                    const { return (m_pLevelTier!=0 && m_pProfile!=0) ? (m_pProfile->minCrScaleFactorx10 * m_pLevelTier->minCrBase[m_tier?1:0])/10.0 : 0.0 ; }   // currently not used for checking
+    UInt getMaxRawCtuBits()              const { return m_maxRawCtuBits; }
+};
+
+
+class TDecConformanceCheck
+{
+private:
+#if MCTS_ENC_CHECK
+  Bool m_tmctsCheckEnabled;
+#endif
+#if DECODER_PARTIAL_CONFORMANCE_CHECK
+  UInt  m_numberOfSlicesInPicture;
+  UInt64 m_bytesInPicture;
+#endif
+  ProfileLevelTierFeatures m_activatedFeatures;
+
+public:
+
+  // Static member functions
+
+  static inline Bool doChecking()
+  {
+    return DECODER_PARTIAL_CONFORMANCE_CHECK != 0;
+  }
+
+  static UInt getMinLog2CtbSize(const TComPTL &ptl, UInt layerPlus1=0);
+  static UInt getMaxLog2CtbSize(const TComPTL &ptl, UInt layerPlus1=0);
+
+
+#if DECODER_PARTIAL_CONFORMANCE_CHECK == 0
+  static inline std::ostream &getStream()  { return std::cout; }
+
+  static inline Void finishWarningReport() { }
+
+  template <class T>
+  static Void checkRange(const T& , const TChar *, const T& , const T& ) { }
+
+#else
+
+
+  static inline std::ostream &getStream()
+  {
+#if DECODER_PARTIAL_CONFORMANCE_CHECK == 1
+    std::cout << "WARNING: Conformance failure - ";
+    return std::cout;
+#else
+    std::cerr << "ERROR: Conformance failure - ";
+    return std::cerr;
+#endif
+  }
+
+  static inline Void finishWarningReport()
+  {
+#if DECODER_PARTIAL_CONFORMANCE_CHECK == 2
+    exit(1);
+#endif
+  }
+
+  template <class T>
+  static Void checkRange(const T& val, const TChar *name, const T& minValInclusive, const T& maxValInclusive)
+  {
+    if (val<minValInclusive || val>maxValInclusive)
+    {
+      getStream() << name << " must be in the range of " << minValInclusive << " to " << maxValInclusive << " (inclusive) - decoded value of " << val << "\n";
+      finishWarningReport();
+    }
+  }
+
+#endif
+
+
+  // Member functions
+
+  TDecConformanceCheck();
+
+#if DECODER_PARTIAL_CONFORMANCE_CHECK == 0
+  Void
+  checkSliceActivation(const TComSlice &/*slice*/,
+                       const InputNALUnit &/*nalu*/,
+                       const TComPic &/*pic*/,
+                       const Bool /*bFirstSliceInStream*/,
+                       const Bool /*bFirstSliceInSequence*/,
+                       const Bool /*bFirstSliceInPicture*/) { }
+
+  Void
+  checkCtuDecoding(const UInt numUsedBits) { }
+#else
+  Void
+  checkSliceActivation(const TComSlice &slice,
+                       const InputNALUnit &nalu,
+                       const TComPic &pic,
+                       const Bool bFirstSliceInStream,
+                       const Bool bFirstSliceInSequence,
+                       const Bool bFirstSliceInPicture);
+
+  Void
+  checkCtuDecoding(const UInt numUsedBits);
+#endif
+
+#if MCTS_ENC_CHECK
+  Void enableTMctsCheck(Bool enabled) { m_tmctsCheckEnabled = enabled; };
+  Bool getTMctsCheck() const { return m_tmctsCheckEnabled;  }
+  Void flagTMctsError(const char *error)
+  {
+    fprintf(stderr, "TMCTS check error: %s\n", error);
+  }
+#endif
+};
+
+
+#endif
Index: /trunk/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -52,5 +52,5 @@
   m_ppcYuvReco = NULL;
   m_ppcCU      = NULL;
-#if NH_3D_DBBP
+#if NH_3D
   m_ppcYuvRecoDBBP = NULL;
 #endif
@@ -61,9 +61,16 @@
 }
 
+#if MCTS_ENC_CHECK
+Void TDecCu::init( TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction, TDecConformanceCheck* pConformanceCheck)
+#else
 Void TDecCu::init( TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction)
+#endif
 {
   m_pcEntropyDecoder  = pcEntropyDecoder;
   m_pcTrQuant         = pcTrQuant;
   m_pcPrediction      = pcPrediction;
+#if MCTS_ENC_CHECK
+  m_pConformanceCheck = pConformanceCheck;
+#endif
 }
 
@@ -81,5 +88,5 @@
   m_ppcYuvReco = new TComYuv*[m_uiMaxDepth-1];
   m_ppcCU      = new TComDataCU*[m_uiMaxDepth-1];
-#if NH_3D_DBBP
+#if NH_3D
   m_ppcYuvRecoDBBP = new TComYuv*[m_uiMaxDepth-1];
 #endif
@@ -102,5 +109,5 @@
     m_ppcYuvReco[ui] = new TComYuv;    m_ppcYuvReco[ui]->create( uiWidth, uiHeight, chromaFormatIDC );
     m_ppcCU     [ui] = new TComDataCU; m_ppcCU     [ui]->create( chromaFormatIDC, uiNumPartitions, uiWidth, uiHeight, true, uiMaxWidth >> (m_uiMaxDepth - 1) );
-#if NH_3D_DBBP
+#if NH_3D
     m_ppcYuvRecoDBBP[ui] = new TComYuv;    m_ppcYuvRecoDBBP[ui]->create( uiWidth, uiHeight, chromaFormatIDC );
 #endif
@@ -126,5 +133,5 @@
     m_ppcYuvReco[ui]->destroy(); delete m_ppcYuvReco[ui]; m_ppcYuvReco[ui] = NULL;
     m_ppcCU     [ui]->destroy(); delete m_ppcCU     [ui]; m_ppcCU     [ui] = NULL;
-#if NH_3D_DBBP
+#if NH_3D
     m_ppcYuvRecoDBBP[ui]->destroy(); delete m_ppcYuvRecoDBBP[ui]; m_ppcYuvRecoDBBP[ui] = NULL;
 #endif
@@ -134,5 +141,5 @@
   delete [] m_ppcYuvReco; m_ppcYuvReco = NULL;
   delete [] m_ppcCU     ; m_ppcCU      = NULL;
-#if NH_3D_DBBP
+#if NH_3D
   delete [] m_ppcYuvRecoDBBP; m_ppcYuvRecoDBBP = NULL;
 #endif
@@ -170,5 +177,5 @@
 Void TDecCu::decompressCtu( TComDataCU* pCtu )
 {
-#if !NH_3D_IV_MERGE
+#if !NH_3D
   xDecompressCU( pCtu, 0,  0 );
 #endif
@@ -290,43 +297,13 @@
     pcCU->setQPSubParts( pcCU->getRefQP(uiAbsPartIdx), uiAbsPartIdx, uiDepth ); // set QP to default QP
   }
-#if NH_3D_NBDV 
+#if NH_3D
   DisInfo DvInfo; 
   DvInfo.m_acNBDV.setZero();
   DvInfo.m_aVIdxCan = 0;
-#if NH_3D_NBDV_REF  
   DvInfo.m_acDoNBDV.setZero();
-#endif
- 
-if(!pcCU->getSlice()->isIntra())
-  {
-#if NH_3D_ARP && NH_3D_IV_MERGE && NH_3D_VSP
+
+  if(!pcCU->getSlice()->isIntra())
+  {
     if( pcCU->getSlice()->getIvResPredFlag() || pcCU->getSlice()->getIvMvPredFlag() || pcCU->getSlice()->getViewSynthesisPredFlag() )
-#else 
-#if NH_3D_IV_MERGE && NH_3D_VSP
-    if( pcCU->getSlice()->getIvMvPredFlag() || pcCU->getSlice()->getViewSynthesisPredFlag() )
-#else
-#if NH_3D_ARP && NH_3D_VSP
-    if( pcCU->getSlice()->getIvResPredFlag() || pcCU->getSlice()->getViewSynthesisPredFlag() )
-#else
-#if NH_3D_VSP
-    if( pcCU->getSlice()->getViewSynthesisPredFlag() )
-#else
-#if H_3D_ARP
-    if( pcCU->getSlice()->getIvResPredFlag( ) )
-#else
-#if H_3D_IV_MERGE
-    if( pcCU->getSlice()->getVPS()->getIvMvPredFlag(pcCU->getSlice()->getLayerId()) )
-#else
-#if NH_3D_DBBP
-    if( pcCU->getSlice()->getDepthBasedBlkPartFlag() )
-#else
-    if (0)
-#endif
-#endif
-#endif
-#endif
-#endif
-#endif
-#endif
     {
       m_ppcCU[uiDepth]->copyInterPredInfoFrom(pcCU, uiAbsPartIdx, REF_PIC_LIST_0, true);
@@ -338,5 +315,4 @@
       m_ppcCU[uiDepth]->setHeight(0, pcCU->getSlice()->getSPS()->getMaxCUHeight() / (1 << uiDepth));
       m_ppcCU[uiDepth]->setPartSizeSubParts(SIZE_2Nx2N, 0, uiDepth);     
-#if NH_3D_IV_MERGE
       if( pcCU->getSlice()->getIsDepth())
       {
@@ -345,18 +321,13 @@
       else
       {
-#endif
-#if NH_3D_NBDV_REF
-      if( pcCU->getSlice()->getDepthBasedBlkPartFlag() )  //Notes from QC: please check the condition for DoNBDV. Remove this comment once it is done.
-      {
-        m_ppcCU[uiDepth]->getDisMvpCandNBDV(&DvInfo, true);
-      }
-      else
-#endif
-      {
-        m_ppcCU[uiDepth]->getDisMvpCandNBDV(&DvInfo);
-      }
-#if NH_3D_IV_MERGE
-      }
-#endif
+        if( pcCU->getSlice()->getDepthBasedBlkPartFlag() )  //Notes from QC: please check the condition for DoNBDV. Remove this comment once it is done.
+        {
+          m_ppcCU[uiDepth]->getDisMvpCandNBDV(&DvInfo, true);
+        }
+        else
+        {
+          m_ppcCU[uiDepth]->getDisMvpCandNBDV(&DvInfo);
+        }
+      }
 #if ENC_DEC_TRACE && NH_MV_ENC_DEC_TRAC   
       if ( g_decTraceDispDer )
@@ -373,5 +344,5 @@
       m_ppcCU[uiDepth]->setWidth(0, cWidTemp);
       m_ppcCU[uiDepth]->setHeight(0, cHeightTemp);
-     }
+    }
   }
 #endif
@@ -382,5 +353,5 @@
   }
 
-  if (pps.getTransquantBypassEnableFlag())
+  if (pps.getTransquantBypassEnabledFlag())
   {
     m_pcEntropyDecoder->decodeCUTransquantBypassFlag( pcCU, uiAbsPartIdx, uiDepth );
@@ -403,10 +374,6 @@
     m_ppcCU[uiDepth]->copyInterPredInfoFrom( pcCU, uiAbsPartIdx, REF_PIC_LIST_0 );
     m_ppcCU[uiDepth]->copyInterPredInfoFrom( pcCU, uiAbsPartIdx, REF_PIC_LIST_1 );
-#if NH_3D_IV_MERGE
+#if NH_3D
     m_ppcCU[uiDepth]->copyDVInfoFrom(pcCU, uiAbsPartIdx);
-    TComMvField cMvFieldNeighbours[MRG_MAX_NUM_CANDS_MEM << 1]; // double length for mv of both lists
-    UChar uhInterDirNeighbours[MRG_MAX_NUM_CANDS_MEM];
-#else
-#if NH_3D_MLC
     TComMvField cMvFieldNeighbours[MRG_MAX_NUM_CANDS_MEM << 1]; // double length for mv of both lists
     UChar uhInterDirNeighbours[MRG_MAX_NUM_CANDS_MEM];
@@ -415,5 +382,4 @@
     UChar uhInterDirNeighbours[MRG_MAX_NUM_CANDS];
 #endif
-#endif
     Int numValidMergeCand = 0;
     for( UInt ui = 0; ui < m_ppcCU[uiDepth]->getSlice()->getMaxNumMergeCand(); ++ui )
@@ -423,17 +389,11 @@
     m_pcEntropyDecoder->decodeMergeIndex( pcCU, 0, uiAbsPartIdx, uiDepth );
     UInt uiMergeIndex = pcCU->getMergeIndex(uiAbsPartIdx);
-#if NH_3D_ARP
+#if NH_3D
     m_pcEntropyDecoder->decodeARPW( pcCU , uiAbsPartIdx , uiDepth );
-#endif
-#if NH_3D_IC
     m_pcEntropyDecoder->decodeICFlag( pcCU, uiAbsPartIdx, uiDepth );
-#endif
-
-
-#if NH_3D_VSP
+
     Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
     memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-#endif
-#if NH_3D_SPIVMP
+
     Bool bSPIVMPFlag[MRG_MAX_NUM_CANDS_MEM];
     memset(bSPIVMPFlag, false, sizeof(Bool)*MRG_MAX_NUM_CANDS_MEM);
@@ -442,27 +402,21 @@
     pcMvFieldSP = new TComMvField[pcCU->getPic()->getPicSym()->getNumPartitionsInCtu()*2]; 
     puhInterDirSP = new UChar[pcCU->getPic()->getPicSym()->getNumPartitionsInCtu()]; 
-#endif
-
-#if NH_3D_MLC
     m_ppcCU[uiDepth]->initAvailableFlags();
 #endif
+#if MCTS_ENC_CHECK
+    UInt numSpatialMergeCandidates = 0;
+    m_ppcCU[uiDepth]->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, numSpatialMergeCandidates, uiMergeIndex );
+#if MCTS_ENC_CHECK
+    if ( m_pConformanceCheck->getTMctsCheck() && m_ppcCU[uiDepth]->isLastColumnCTUInTile() && (uiMergeIndex >= numSpatialMergeCandidates) )
+    {
+      m_pConformanceCheck->flagTMctsError("Merge Index using non-spatial merge candidate (Skip)");
+    }
+#endif
+#else
     m_ppcCU[uiDepth]->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, uiMergeIndex );
-#if NH_3D_MLC
-    m_ppcCU[uiDepth]->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours 
-#if NH_3D_SPIVMP
-      , pcMvFieldSP, puhInterDirSP
-#endif
-      , numValidMergeCand, uiMergeIndex );
-
-    m_ppcCU[uiDepth]->buildMCL( cMvFieldNeighbours, uhInterDirNeighbours
-#if NH_3D_VSP
-      , vspFlag
-#endif
-#if NH_3D_SPIVMP
-      , bSPIVMPFlag
-#endif
-      , numValidMergeCand );
-#endif
-#if NH_3D_VSP
+#endif
+#if NH_3D
+    m_ppcCU[uiDepth]->xGetInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, pcMvFieldSP, puhInterDirSP, numValidMergeCand, uiMergeIndex );
+    m_ppcCU[uiDepth]->buildMCL( cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, bSPIVMPFlag, numValidMergeCand );
     pcCU->setVSPFlagSubParts( vspFlag[uiMergeIndex], uiAbsPartIdx, 0, uiDepth );
 #endif
@@ -479,5 +433,5 @@
         pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->setAllMvd( cTmpMv, SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
         pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->setAllMvField( cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ], SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
-#if NH_3D_VSP
+#if NH_3D
         if( pcCU->getVSPFlag( uiAbsPartIdx ) != 0 )
         {
@@ -512,5 +466,5 @@
       }
     }
-#if NH_3D_SPIVMP
+#if NH_3D
     pcCU->setSPIVMPFlagSubParts(bSPIVMPFlag[uiMergeIndex], uiAbsPartIdx, 0, uiDepth ); 
     if (bSPIVMPFlag[uiMergeIndex])
@@ -570,5 +524,5 @@
 
     xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, isLastCtuOfSliceSegment );
-#if NH_3D_IV_MERGE
+#if NH_3D
     xDecompressCU(pcCU, uiAbsPartIdx, uiDepth );
 #endif
@@ -576,5 +530,5 @@
     return;
   }
-#if NH_3D_DIS
+#if NH_3D
   m_pcEntropyDecoder->decodeDIS( pcCU, uiAbsPartIdx, uiDepth );
   if(!pcCU->getDISFlag(uiAbsPartIdx))
@@ -582,38 +536,38 @@
 #endif
 
-  m_pcEntropyDecoder->decodePredMode( pcCU, uiAbsPartIdx, uiDepth );
-  m_pcEntropyDecoder->decodePartSize( pcCU, uiAbsPartIdx, uiDepth );
-
-  if (pcCU->isIntra( uiAbsPartIdx ) && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N )
-  {
-    m_pcEntropyDecoder->decodeIPCMInfo( pcCU, uiAbsPartIdx, uiDepth );
-
-    if(pcCU->getIPCMFlag(uiAbsPartIdx))
-    {
-#if NH_3D_SDC_INTRA
-      m_pcEntropyDecoder->decodeSDCFlag( pcCU, uiAbsPartIdx, uiDepth );
-#endif
-      xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, isLastCtuOfSliceSegment );
-#if NH_3D_IV_MERGE
-      xDecompressCU(pcCU, uiAbsPartIdx, uiDepth );
-#endif
-      return;
-    }
-  }
-
-  // prediction mode ( Intra : direction mode, Inter : Mv, reference idx )
-  m_pcEntropyDecoder->decodePredInfo( pcCU, uiAbsPartIdx, uiDepth, m_ppcCU[uiDepth]);
-
-  // Coefficient decoding
-  Bool bCodeDQP = getdQPFlag();
-  Bool isChromaQpAdjCoded = getIsChromaQpAdjCoded();
-  m_pcEntropyDecoder->decodeCoeff( pcCU, uiAbsPartIdx, uiDepth, bCodeDQP, isChromaQpAdjCoded );
-  setIsChromaQpAdjCoded( isChromaQpAdjCoded );
-  setdQPFlag( bCodeDQP );
-#if NH_3D_DIS
+    m_pcEntropyDecoder->decodePredMode( pcCU, uiAbsPartIdx, uiDepth );
+    m_pcEntropyDecoder->decodePartSize( pcCU, uiAbsPartIdx, uiDepth );
+
+    if (pcCU->isIntra( uiAbsPartIdx ) && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N )
+    {
+      m_pcEntropyDecoder->decodeIPCMInfo( pcCU, uiAbsPartIdx, uiDepth );
+
+      if(pcCU->getIPCMFlag(uiAbsPartIdx))
+      {
+#if NH_3D
+        m_pcEntropyDecoder->decodeSDCFlag( pcCU, uiAbsPartIdx, uiDepth );
+#endif
+        xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, isLastCtuOfSliceSegment );
+#if NH_3D
+        xDecompressCU(pcCU, uiAbsPartIdx, uiDepth );
+#endif
+        return;
+      }
+    }
+
+    // prediction mode ( Intra : direction mode, Inter : Mv, reference idx )
+    m_pcEntropyDecoder->decodePredInfo( pcCU, uiAbsPartIdx, uiDepth, m_ppcCU[uiDepth]);
+
+    // Coefficient decoding
+    Bool bCodeDQP = getdQPFlag();
+    Bool isChromaQpAdjCoded = getIsChromaQpAdjCoded();
+    m_pcEntropyDecoder->decodeCoeff( pcCU, uiAbsPartIdx, uiDepth, bCodeDQP, isChromaQpAdjCoded );
+    setIsChromaQpAdjCoded( isChromaQpAdjCoded );
+    setdQPFlag( bCodeDQP );
+#if NH_3D
   }
 #endif
   xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, isLastCtuOfSliceSegment );
-#if NH_3D_IV_MERGE
+#if NH_3D
   xDecompressCU(pcCU, uiAbsPartIdx, uiDepth );
 #endif
@@ -638,5 +592,5 @@
 {
   TComPic* pcPic = pCtu->getPic();
-#if !NH_3D_IV_MERGE
+#if !NH_3D
   TComSlice * pcSlice = pCtu->getSlice();
   const TComSPS &sps=*(pcSlice->getSPS());
@@ -681,5 +635,5 @@
   {
     case MODE_INTER:
-#if NH_3D_DBBP
+#if NH_3D
     if( m_ppcCU[uiDepth]->getDBBPFlag(0) )
     {
@@ -688,6 +642,4 @@
     else
     {
-#endif
-#if NH_3D_SDC_INTER
       if( m_ppcCU[uiDepth]->getSDCFlag( 0 ) )
       {
@@ -698,8 +650,6 @@
 #endif
       xReconInter( m_ppcCU[uiDepth], uiDepth );
-#if NH_3D_SDC_INTER
-      }
-#endif
-#if NH_3D_DBBP
+#if NH_3D
+      }
     }
 #endif
@@ -707,21 +657,12 @@
     case MODE_INTRA:
 #if NH_3D
-#if NH_3D_DIS
     if( m_ppcCU[uiDepth]->getDISFlag(0) )
     {
       xReconDIS( m_ppcCU[uiDepth], 0, uiDepth );
     }
-#else
-    if(false )
-    {
-     // xReconDIS( m_ppcCU[uiDepth], 0, uiDepth );
-    }
-#endif
-#if NH_3D_SDC_INTRA
     else if( m_ppcCU[uiDepth]->getSDCFlag(0) )
     {
       xReconIntraSDC( m_ppcCU[uiDepth], 0, uiDepth );
     }
-#endif
     else
 #endif
@@ -756,4 +697,10 @@
 
   // inter prediction
+#if MCTS_ENC_CHECK
+  if (m_pConformanceCheck->getTMctsCheck()  && !m_pcPrediction->checkTMctsMvp(pcCU))
+  {
+    m_pConformanceCheck->flagTMctsError("motion vector across tile boundaries");
+  }
+#endif
   m_pcPrediction->motionCompensation( pcCU, m_ppcYuvReco[uiDepth] );
 
@@ -794,5 +741,5 @@
 }
 
-#if NH_3D_DIS
+#if NH_3D
 Void TDecCu::xReconDIS( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -869,6 +816,5 @@
   }
 }
-#endif
-#if NH_3D_SDC_INTER
+
 Void TDecCu::xReconInterSDC( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -913,7 +859,5 @@
   }
 }
-#endif
-
-#if NH_3D_DBBP
+
 Void TDecCu::xReconInterDBBP( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -926,9 +870,5 @@
   // get collocated depth block
   UInt uiDepthStride = 0;
-#if H_3D_FCO
-  Pel* pDepthPels = pcCU->getVirtualDepthBlock(pcCU->getZorderIdxInCU(), pcCU->getWidth(0), pcCU->getHeight(0), uiDepthStride);
-#else
   Pel* pDepthPels = pcCU->getVirtualDepthBlock(0, pcCU->getWidth(0), pcCU->getHeight(0), uiDepthStride);
-#endif
   AOF( pDepthPels != NULL );
   AOF( uiDepthStride != 0 );
@@ -956,11 +896,9 @@
       pcCU->getMvField(pcCU, uiPartAddr, eRefList, pDBBPTmpData->acMvField[uiSegment][eRefList]);
     }
-    
-#if NH_3D
+
     AOF( pcCU->getARPW(uiPartAddr) == 0 );
     AOF( pcCU->getICFlag(uiPartAddr) == false );
     AOF( pcCU->getSPIVMPFlag(uiPartAddr) == false );
     AOF( pcCU->getVSPFlag(uiPartAddr) == 0 );
-#endif
   }
   
@@ -1081,5 +1019,5 @@
 
   //===== get prediction signal =====
-#if NH_3D_DMM
+#if NH_3D
   if( bIsLuma && isDmmMode( uiChFinalMode ) )
   {
@@ -1090,5 +1028,5 @@
 #endif
   m_pcPrediction->predIntraAng( compID,   uiChFinalMode, 0 /* Decoder does not have an original image */, 0, piPred, uiStride, rTu, bUseFilteredPredictions );
-#if NH_3D_DMM
+#if NH_3D
   }
 #endif
@@ -1255,5 +1193,5 @@
 }
 
-#if NH_3D_SDC_INTRA
+#if NH_3D
 Void TDecCu::xReconIntraSDC( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -1284,5 +1222,4 @@
   UInt uiMaskStride = 0;
 
-#if NH_3D_DMM
   if( isDmmMode( uiLumaPredMode ) )
   {
@@ -1330,5 +1267,5 @@
   else // regular HEVC intra modes
   {
-#endif
+
     uiNumSegments = 1;
 
@@ -1389,13 +1326,10 @@
 
     m_pcPrediction->predConstantSDC( piPred, uiStride, uiWidth, apDCPredValues[0] ); apDCPredValues[1] = 0;
-#if NH_3D_DMM
-  }
-#endif
-  
+  }
+
   // reconstruct residual based on mask + DC residuals
   Pel apDCResiValues[2];
   for( UInt uiSegment = 0; uiSegment < uiNumSegments; uiSegment++ )
   {
-#if NH_3D_DLT
     Pel   pPredIdx    = pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), apDCPredValues[uiSegment] );
     Pel   pResiIdx    = pcCU->getSDCSegmentDCOffset(uiSegment, uiAbsPartIdx);
@@ -1403,7 +1337,4 @@
 
     apDCResiValues[uiSegment]  = pRecoValue - apDCPredValues[uiSegment];
-#else
-    apDCResiValues[uiSegment]  = pcCU->getSDCSegmentDCOffset(uiSegment, uiAbsPartIdx);
-#endif
   }
   
@@ -1450,7 +1381,5 @@
     pRecCr += uiStrideC;
   }
-#if NH_3D_DMM
   if( pbMask ) { delete[] pbMask; }
-#endif
 }
 #endif
Index: /trunk/source/Lib/TLibDecoder/TDecCu.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecCu.h	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/TDecCu.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -45,4 +45,5 @@
 #include "TLibCommon/TComTrQuant.h"
 #include "TDecEntropy.h"
+#include "TDecConformance.h"
 
 //! \ingroup TLibDecoder
@@ -62,5 +63,5 @@
   TComDataCU**        m_ppcCU;            ///< CU data array
 
-#if NH_3D_DBBP
+#if NH_3D
   TComYuv**           m_ppcYuvRecoDBBP;
 #endif
@@ -70,4 +71,7 @@
   TComPrediction*     m_pcPrediction;
   TDecEntropy*        m_pcEntropyDecoder;
+#if MCTS_ENC_CHECK
+  TDecConformanceCheck* m_pConformanceCheck;
+#endif
 
   Bool                m_bDecodeDQP;
@@ -79,5 +83,9 @@
 
   /// initialize access channels
+#if MCTS_ENC_CHECK
+  Void  init                    (TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction, TDecConformanceCheck* pConformanceCheck);
+#else
   Void  init                    ( TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction );
+#endif
 
   /// create internal buffers
@@ -102,5 +110,5 @@
   Void xReconInter              ( TComDataCU* pcCU, UInt uiDepth );
 
-#if NH_3D_DBBP
+#if NH_3D
   Void xReconInterDBBP          ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
@@ -124,11 +132,7 @@
   Void xFillPCMBuffer           (TComDataCU* pCU, UInt depth);
 
-#if NH_3D_DIS
+#if NH_3D
   Void xReconDIS               ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
-#endif
-#if NH_3D_SDC_INTRA
   Void xReconIntraSDC           ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
-#endif
-#if NH_3D_SDC_INTER
   Void xReconInterSDC           ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
